package com.ruoyi.web.base.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.framework.web.service.TokenService;
import com.ruoyi.web.base.domain.BaseProductType;
import com.ruoyi.web.base.service.IBaseProductTypeService;
import com.ruoyi.web.base.service.IBaseProductTypeService;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

import static com.ruoyi.common.core.domain.AjaxResult.success;
import static com.ruoyi.common.utils.SecurityUtils.getUsername;

/**
 * <p>
 * 产品类型 前端控制器
 * </p>
 *
 * @author author
 * @since 2026-02-06
 */
@RestController
@RequestMapping("/base-product-type")
public class BaseProductTypeController {

    @Autowired
    private IBaseProductTypeService  baseProductTypeService;
    @Autowired
    private TokenService tokenService;

    @ApiOperation("产品类型管理添加")
    @PostMapping("/add")
    public AjaxResult add(@RequestBody BaseProductType baseProductType, HttpServletRequest request) throws Exception {
        String loginOrgId = tokenService.getLoginOrgId(request);
        if (baseProductTypeService.count(new QueryWrapper<BaseProductType>().eq("org_id",loginOrgId).eq("type_num", baseProductType.getTypeNum())) >0 ){
            throw new Exception("该编号已存在");
        }
        baseProductType.setOrgId(loginOrgId);
        baseProductType.setCreateBy(getUsername());

        return success(baseProductTypeService.save(baseProductType));
    }

    @ApiOperation("仓库管理修改")
    @PostMapping("/edit")
    public AjaxResult edit(@RequestBody BaseProductType baseProductType, HttpServletRequest request) throws Exception {
        String loginOrgId = tokenService.getLoginOrgId(request);
        if (baseProductTypeService.count(new QueryWrapper<BaseProductType>().ne("id",baseProductType.getId()).eq("org_id",loginOrgId).eq("type_num", baseProductType.getTypeNum())) >0 ){
            throw new Exception("该编号已存在");
        }
        baseProductType.setUpdateBy(getUsername());
        return success(baseProductTypeService.updateById(baseProductType));
    }

    @ApiOperation("仓库管理删除")
    @PostMapping("/delete")
    public AjaxResult delete(@RequestBody Map<String, String> paramsMap) {
        String ids = paramsMap.get("ids");
        for (String s : ids.split(",")) {
            baseProductTypeService.removeById(s);
        }
        return success();
    }

    @ApiOperation("仓库管理列表")
    @PostMapping("/list")
    public AjaxResult listAll( HttpServletRequest request){

        return success(baseProductTypeService.list(new QueryWrapper<BaseProductType>().eq("org_id", tokenService.getLoginOrgId(request))));
    }

    @ApiOperation("仓库管理分页")
    @GetMapping("/page")
    public AjaxResult page(@RequestParam("pageNum") Integer pageNum, @RequestParam("pageSize") Integer pageSize
            , HttpServletRequest request) {
        return success(baseProductTypeService.page(new Page<BaseProductType>(pageNum,pageSize),new QueryWrapper<BaseProductType>().eq("org_id", tokenService.getLoginOrgId(request))));
    }

    @ApiOperation("仓库管理详情")
    @PostMapping("/listById")
    public AjaxResult listById(@RequestBody Map<String, String> paramsMap){
        String id = paramsMap.get("id");
        return success(baseProductTypeService.getById(id));
    }

}
